/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2008 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.jaas;

import java.security.GeneralSecurityException;

import javax.security.auth.Subject;
import javax.security.auth.login.LoginContext;

/**
 * The Authentication Service Interface.
 * 
 * @author Christophe HAMERLING - eBM WebSourcing
 * @since 2.2
 * 
 */
public interface AuthenticationService {

    /**
     * Authenticate an user with the given credentials. The subject is filled
     * with the user principals.
     * 
     * @param subject
     * @param domain
     * @param user
     *            the user to authenticate
     * @param credentials
     * @throws GeneralSecurityException
     */
    LoginContext authenticate(Subject subject, String domain, String user, Object credentials)
            throws GeneralSecurityException;

}
